//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) Four IN-14 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:port_bit.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2016/11/27 New  Taishi
//*****************************************
#include	<avr/io.h>


#include	"timer.h"
#include	"port_bit.h"

static	unsigned char	sw[4];				// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;
static	unsigned char	sw_continue_count;

//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
// SW[3] ɗꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc = ((~PIND) & SW_ON_BIT);							// ]ăXCb`f[^擾
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}

//***************************
//@XCb`֌W̏ݒ
//***************************
void	sw_init(void)
{
	DDRD &= ~((1 << DDD3));		// Port-D Bit1,2,4 : Intput
	PORTD |= ((1 << PD3) );		// Port-D Bit1,2,4 : Pullup
	sw_continue_count = 0;

}

#define			TMR_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSWR_ON_CONTINUEvo^C~OɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
unsigned char	get_action_sw(void)
{
	unsigned char	uc=0;

	get_sw();												// XCb`Ԃ

	if((sw[2] & SW_ON_BIT) != 0){							// XCb`nm̏uԂ̎
		uc |= (SW_ON_NOW | SW_ON);
		tim_10ms_sw_continue = TMR_CONTIMUE;
		tim_10ms_sw_length = TMR_LONG;
		sw_continue_count = 1;
	}else if((sw[1] & SW_ON_BIT) != 0){						// XCb`nm̎
		uc |= SW_ON;
		if(tim_10ms_sw_continue == 0){						// ꑱo^C~O̎
			uc |= SW_ON_CONTINUE;
			if(sw_continue_count < 2){
				sw_continue_count++;
				tim_10ms_sw_continue = TMR_CONTIMUE;
			}else{
				tim_10ms_sw_continue = TMR_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW_ON_BIT) != 0){						// XCb`ꂽuԂ̎
		if(tim_10ms_sw_length == 0){						// ꂽԂ
			uc |= SW_OFF_LONG;
		}else{												// ꂽԂZ
			uc |= SW_OFF_SHORT;
		}
		tim_10ms_sw_continue = 0;
		tim_10ms_sw_length = 0;
		sw_continue_count = 0;
	}else if((sw[1] & SW_ON_BIT) == 0){						// XCb`nee̎
		tim_10ms_sw_continue = 0;
		tim_10ms_sw_length = 0;
		sw_continue_count = 0;
	}

	return(uc);
}

//*****************************************
// XCb`@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//  Timer2 ̊荞݂gpĂԂKv
//*****************************************
void	wait_key_off(void)
{
	while(1){										// rv܂ő҂
		get_action_sw();							//@XCb`Ԃ
		if( (sw[1] & SW_ON_BIT) == 0 ){				// ꂽ
			break;
		}
	}
}
//*****************************************
// XCb`@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if((PIND & SW_ON_BIT) != 0){
			delay_ms(100);												// 100mS Delay
			if((PIND & SW_ON_BIT) != 0){
				break;													// {ɗꂽƂ
			}
		}
	}
}
