//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) Four IN-14 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:six_nixie.c
//
//  2016/11/27 New  Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"four_in14_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"display.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"rtc_ds3234.h"
#include	"set_rtc.h"
#include	"eep_dat.h"

unsigned char			g_keta;

static	unsigned char	run=0;
static	unsigned char	dc_match=0;
static	int				bef1_ad_ave=0;
static	unsigned char	num_count=0;
static	unsigned char	renzoku[16]={1,7,2,8,0,6,3,9,4,5,15,15,15,15,15,15};			// ̑w̑w
static	unsigned char	gyaku_renzoku[16]={5,4,9,3,6,0,8,2,7,1,15,15,15,15,15,15};		// ̑w牺̑w


//***************************
// f[^o͑삷
//***************************
void	output_data(void)
{
	if(run == 0){					// nee̎
		pulse_out = PULSE_OUT_MAX;
		run = 1;					// nm
	}else{							// nm̎
		pulse_out = 0;
		run = 0;					// nee
	}
}
#if	0
//***************************
// `^c̒lłnmpXω
//  `^cl ad6_ave ɂ
//  pX pulse_out ɓ
//***************************
void	feed_back_pro(void)
{
	int		p;
	int		nxt_ad6_ave;
	int		sa;

	p = pulse_out;
	sa = ad6_ave - bef1_ad_ave;
	if(0 < sa){											// o̎
		nxt_ad6_ave = ad6_ave + sa + sa;				// \l傫
	}else{
		nxt_ad6_ave = ad6_ave + sa;
	}

	if (ad6_ave == LEVEL_AD){							// ڕWl̎
		;
	}else if (ad6_ave < LEVEL_AD){						// ܂Ⴂ
		if(LEVEL_AD_L <= ad6_ave){						// ڕWlɗƍl
			p += OUT_BAND;								// ۂ͉Ȃ
		}else if(LEVEL_AD_NL <= nxt_ad6_ave){			// ڕWlɖwǋ߂Âƍl
			p += OUT_NEAR;								// ω
		}else if(LEVEL_AD_ML <= nxt_ad6_ave){			// ڕWlɑ啪߂Âƍl
			p += OUT_MID;								// ω
		}else if(nxt_ad6_ave < LEVEL_AD_ML){			// ڕWlɉƍl
			p += OUT_FAR;								// 傫ω
		}
	}else if (LEVEL_AD < ad6_ave){						// ܂
		if(ad6_ave <= LEVEL_AD_H){						// ڕWlɗƍl
			p -= OUT_BAND;								// ۂ͉Ȃ
		}else if(nxt_ad6_ave <= LEVEL_AD_NH){			// ڕWlɖwǋ߂Âƍl
			p -= OUT_NEAR;								// ω
		}else if(nxt_ad6_ave <= LEVEL_AD_MH){			// ڕWlɑ啪߂Âƍl
			p -= OUT_MID;								// ω
		}else if(LEVEL_AD_MH < nxt_ad6_ave){			// ڕWlɉƍl
			p -= OUT_FAR;								// 傫ω
		}
	}

	if(p < PULSE_OUT_MIN){
		p = PULSE_OUT_MIN;
	}else if(PULSE_OUT_MAX < p){
		p = PULSE_OUT_MAX;
	}

	if((LEVEL_AD - 200) < nxt_ad6_ave){						// QOOO̎
		if(25 < sa){										// ωʂRT𒴂Ă鎞
			p = 200;
		}
	}

	pulse_out = p;

	if((LEVEL_LED_L <= ad6_ave)&&(ad6_ave <= LEVEL_LED_H)){	// kdc_͈͂ɗƍl
		dc_match=1;
	}else{
		dc_match=0;
	}

	bef1_ad_ave = ad6_ave;
}
#else
//***************************
// `^c̒lłnmpXω
//  `^cl ad6_ave ɂ
//  pX pulse_out ɓ
//***************************
void	feed_back_pro(void)
{
	int		p;
	int		ad_ave;
	int		nxt_ad_ave;
	int		sa;

#if	AD_NO == 6
	ad_ave = ad6_ave;
#else
 #if	AD_NO == 5
	ad_ave = ad5_ave;
 #else
	ad_ave = ad0_ave;
 #endif
#endif

	p = pulse_out;
	sa = ad_ave - bef1_ad_ave;
	if(0 < sa){											// o̎
		nxt_ad_ave = ad_ave + sa + sa;				// \l傫
	}else{
		nxt_ad_ave = ad_ave + sa;
	}

	if (ad_ave == LEVEL_AD){							// ڕWl̎
		;
	}else if (ad_ave < LEVEL_AD){						// ܂Ⴂ
		if(LEVEL_AD_L <= ad_ave){						// ڕWlɗƍl
			p += OUT_BAND;								// ۂ͉Ȃ
		}else if(LEVEL_AD_NL <= nxt_ad_ave){			// ڕWlɖwǋ߂Âƍl
			p += OUT_NEAR;								// ω
		}else if(LEVEL_AD_ML <= nxt_ad_ave){			// ڕWlɑ啪߂Âƍl
			p += OUT_MID;								// ω
		}else if(nxt_ad_ave < LEVEL_AD_ML){				// ڕWlɉƍl
			p += OUT_FAR;								// 傫ω
		}
	}else if (LEVEL_AD < ad_ave){						// ܂
		if(ad_ave <= LEVEL_AD_H){						// ڕWlɗƍl
			p -= OUT_BAND;								// ۂ͉Ȃ
		}else if(nxt_ad_ave <= LEVEL_AD_NH){			// ڕWlɖwǋ߂Âƍl
			p -= OUT_NEAR;								// ω
		}else if(nxt_ad_ave <= LEVEL_AD_MH){			// ڕWlɑ啪߂Âƍl
			p -= OUT_MID;								// ω
		}else if(LEVEL_AD_MH < nxt_ad_ave){				// ڕWlɉƍl
			p -= OUT_FAR;								// 傫ω
		}
	}

	if(p < PULSE_OUT_MIN){
		p = PULSE_OUT_MIN;
	}else if(PULSE_OUT_MAX < p){
		p = PULSE_OUT_MAX;
	}

	if((LEVEL_AD - 200) < nxt_ad_ave){						// QOOO̎
		if(25 < sa){										// ωʂRT𒴂Ă鎞
			p = 200;
		}
	}

	pulse_out = p;

	if((LEVEL_LED_L <= ad_ave)&&(ad_ave <= LEVEL_LED_H)){	// kdc_͈͂ɗƍl
		dc_match=1;
	}else{
		dc_match=0;
	}

	bef1_ad_ave = ad_ave;
}
#endif

//***************************
// QOOuۂ
//***************************
void	stabilizer_200v(void)
{
	if(tim_10ms_ad == 0){
		tim_10ms_ad = 10;									// 100mS Ԋuł`^cf[^擾

#if	AD_NO == 6
		ad6_get_data();										//  A/D l̎擾
#else
 #if	AD_NO == 5
		ad5_get_data();										//  A/D l̎擾
 #else
		ad0_get_data();										//  A/D l̎擾
 #endif
#endif

		feed_back_pro();
		set_timer1_ontime();
		if(dc_match==1){
			led_on();										// LED ON
			dynamic_nixie_active(1);
		}else{
			led_off();										// LED OFF
		}
	}
}

//***************************
// `FbNs
//***************************
void	check(void)
{
	unsigned char	uc;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;
	unsigned char	old_keta = 1;
	unsigned char	pause = 0;

	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_off();										// LED OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	output_data();									// f[^o͑삷
	disp_dynamic_nixie_number(1, 8);
	disp_dynamic_nixie_number(0, 8);
	disp_dynamic_nixie_dot(1, 3);
	disp_dynamic_nixie_dot(0, 3);
	led_off();										// LED OFF
	pulse_on();
	tim_10ms_ad = 0;
	for(;;){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// XCb`NbNꂽ
			bef1_ad_ave = 0;
			output_data();										// f[^o͑삷
			edit_eep_data();									// ddoqnlDATAҏWiiv[vj
			break;
		}

		if(uc == SW_OFF_SHORT){									// XCb`NbNꂽ
			break;
		}
		stabilizer_200v();										// QOOuۂ
	}


	for(;;){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ

		if(uc == SW_OFF_SHORT){									// XCb`NbNꂽ
			pause ^= 1;
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;							// 1000mS Ԋu
			if(pause == 0){
				disp_dynamic_nixie_dot(old_keta,0);				// _
				if(old_keta != keta){							// ς
					disp_dynamic_nixie_number(old_keta, 15);	// Ǒ̐
					old_keta = keta;
				}
				if(kazu == 10){
					disp_dynamic_nixie_dot(keta,2);				// _
					disp_dynamic_nixie_number(keta, 15);		// 
				}else if(kazu == 11){
					disp_dynamic_nixie_dot(keta,1);				// E_
					disp_dynamic_nixie_number(keta, 15);		// 
				}else{
					disp_dynamic_nixie_number(keta, kazu);		// 
				}
				kazu++;
				if(11 < kazu){									// Oɖ߂
					kazu = 0;
					keta++;
					if(g_keta == keta){							// ԉE̕\iƗRj̎
						kazu = 11;
					}else if(g_keta < keta){					// \߂
						keta = 0;
					}
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}

}
//***************************
// Aj[V\
//@ODPbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_keta = 0;		//  0--5
	static	unsigned char	ani_kazu = 0;		// l 0--9, 10=colon
	unsigned char			r = 0;
	unsigned char			kazu_max = 9;

	if (init == 1){
		ani_keta = 0;
		ani_kazu = 0;
	}else{
		if(ani_kazu == 0){
			for(ani_kazu=0;ani_kazu <= g_keta;ani_kazu++){
				disp_dynamic_nixie_number(ani_kazu, 15);
				disp_dynamic_nixie_dot(ani_kazu, 0);
			}
			ani_kazu = 0;
		}

		if(ani_keta == g_keta){									// ŉEiƗRj
				disp_dynamic_nixie_number(ani_keta, 15);
				disp_dynamic_nixie_dot(ani_keta, 1);
				kazu_max = 1;
		}else{
			if((ani_keta & 1) == 0){									// 
				disp_dynamic_nixie_number(ani_keta, renzoku[ani_kazu]);
			}else{														// E
				disp_dynamic_nixie_number(ani_keta, gyaku_renzoku[ani_kazu]);
			}
			if(ani_kazu == 10){
				disp_dynamic_nixie_dot(ani_keta, 2);
			}else if(ani_kazu == 11){
				disp_dynamic_nixie_dot(ani_keta, 1);
			}else{
				disp_dynamic_nixie_dot(ani_keta, 0);
			}
			kazu_max = 11;
		}
		ani_kazu++;
		if(kazu_max < ani_kazu){
			ani_kazu = 0;
			ani_keta++;								// ̌
			if(g_keta < ani_keta){
				ani_keta = 0;
				r = 1;
			}
		}
	}

	return(r);
}

//***************************
//  Sp Main
//***************************
static	void	main_4keta(void)
{
	char			uc;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;

	sei();											// 荞݉

	bef1_ad_ave = 0;
	pulse_out = PULSE_OUT_MAX;
	pulse_on();										// 200V Output Start

	tim_10ms_nixie = 100;

	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_RTC_min = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(uc == SW_OFF_SHORT){							// Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				break;
			 case YE:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){				// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();									// RTC ǂݏo
				if(disp_clock_mode == HM){					// [h
					disp_dynamic_nixie_dot(4, 1);			// R\ _
					tim_10ms_nixie = 50;
					if((old_RTC_hou != gRTC_hou)||(old_RTC_min != gRTC_min)){	//  ω
						disp_nixie_four(gRTC_hou,gRTC_min);		// ƕ S\
						old_RTC_hou = gRTC_hou;
						old_RTC_min = gRTC_min;
						if((gRTC_min == 0)&&(gRTC_sec == 0)){	// ̎
							disp_dynamic_nixie_dot(4, 0);		// R\ 
							disp_clock_mode = ANIME;
							disp_animation(1);					// Aj[V
							old_disp_clock_mode = HM;
						}
					}
				}else if((disp_clock_mode == MD)&&((old_RTC_mon != gRTC_mon)||(old_RTC_day != gRTC_day))){	// [h ω
					disp_nixie_four(gRTC_mon,gRTC_day);		// Ɠ S\
					old_RTC_mon = gRTC_mon;
					old_RTC_day = gRTC_day;
					disp_dynamic_nixie_dot(4, 1);			// R\ _
				}else if((disp_clock_mode == YE)&&(old_RTC_year != gRTC_year)){	// N[h Nω
					disp_nixie_four(0x20,gRTC_year);		// N S\
					old_RTC_year = gRTC_year;
					disp_dynamic_nixie_dot(4, 0);			// R\ 
				}
				num_count=0;
			}

			if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
				if((disp_clock_mode != HM)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HM;
				}
			}

			if(tim_10ms_nixie == 0){						// TOO
				if(disp_clock_mode == ANIME){			// Aj[V̎
					tim_10ms_nixie = 20;						// POOr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_year = 0xff;
					}
				}else if(disp_clock_mode == HM){				// ̎
					disp_dynamic_nixie_dot(4, 0);				// R\ 
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}
}

//***************************
//  Main
//***************************
int	main(void)
{

#if	0
	char			uc;
	unsigned char	disp_clock_mode=HMS;
	unsigned char	old_disp_clock_mode=HMS;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_sec = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
#endif

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay


	init_nixe();									// Nixe\ 
	sw_init();										// XCb`֌W̏ݒ
	rtc_init();										// qsb̏ݒ
	led_init();										// kdc֌W̏ݒ
	timer1_init();									// Timer1 Initial
	timer2_init();									// Timer2 Initial

#if	AD_NO == 6
	ad6_init();										// A/D 6 Initial
#else
 #if	AD_NO == 5
	ad5_init();										// A/D 5 Initial
 #else
	ad0_init();										// A/D 0 Initial
 #endif
#endif

	g_keta = 4;										// KETA = 4 Œ
	path_limit = read_eep_path();					// ddoqnl PATH_limit ǂݍ

	if((PIND & SW_ON_BIT) == 0){					// XCb`f[^Ă
		check();									// `FbNs
	}

	main_4keta();									// Sp Main

}
